
//wrapped 'loose' variables and functions in bfOverlay object


var bfOverlay = {
		WinObjRef: null,
		clickTimer: undefined,




		ShowPanelLangs: function ()
		{
			var bfsourcemenu = document.getElementById("bf-sourcemenu");
			var bftargetmenu = document.getElementById("bf-targetmenu");
			bfsourcemenu.hidePopup();
			bftargetmenu.hidePopup();
			bfsourcemenu.setAttribute("onpopuphidden", "var cfgBtn = document.getElementById('bfcfgBtn'); var bftargetmenu = document.getElementById('bf-targetmenu'); bftargetmenu.setAttribute('onpopuphidden', 'if(bf.getbabelFish() || bf.isPanelshown()) bf.prepareRequest(bf.service, true, null);'); bf.popup = true; bftargetmenu.showPopup( cfgBtn,-1,-1,'context','topleft','bottomleft');");
			var cfgBtn = document.getElementById("bfcfgBtn");
			bf.popup = true;
			bfsourcemenu.showPopup(cfgBtn,-1,-1,'context','topleft','bottomleft');
		},


		HelpPageDisplay: function(page)
		{
			//dialog window(no js!)
			//window.openDialog("chrome://babelmousish/skin/BabelFish.html", "Welcome to BabelFish", "width=800,height=600,chrome=yes,centerscreen=yes,alwaysRaised=yes,resizable=yes,scrollbars=yes,status=no");
			//standard window (no centerscreen!)
			/*
			if(gBrowser)
			{

				gBrowser.selectedTab = gBrowser.addTab(page); 

				return;
			}
			*/
			if(bfOverlay.WindowObjectReference == null || bfOverlay.WindowObjectReference.closed)
			{
				try{
					bfOverlay.WindowObjectReference = window.open(page, "", "width=800,height=600,alwaysRaised=yes,resizable=yes,scrollbars=yes,status=no");
				}catch(e){;}
        	}
		},


		addCustomLang: function(sel)
		{
			bfOverlay.addToMenu(sel);
		},


		initializeLanguageMenu: function()
		{
			var lang = bf.guessInitLang();
			if (bf.bflangs[lang] != null)
			{
				var sel = "";
				if (lang != "en"){
					sel = sel + ",en" + lang;
				}
				if(lang != "zh"){
					sel = sel + ",zh" + lang;
				}
				if(lang != "ja"){
					sel = sel + ",ja" + lang;
				}
				if(lang != "de"){
					sel = sel + ",de" + lang;
				}
				if(lang != "es"){
					sel = sel + ",es" + lang;
				}
				if(lang != "fr"){
					sel = sel + ",fr" + lang;
				}
				if (lang != "en"){ //also add backwards translation
						sel = sel + "," + lang + "en";
				}
				if(sel.substring(0,1) == ",")
					sel = sel.substring(1,sel.length);
				navigator.preference("extensions.babelmousish.usermenue", sel);
			}else
				navigator.preference("extensions.babelmousish.usermenue", "enzh,enja,ende,enes,enfr");
		},



		addToMenu: function(sel)
		{
				if (sel == null)
					return;
				var a = sel.slice(0, 2);
				var b = sel.slice(2, 4);

				var lbl = "From " + bf.bflangs[a] + " To " + bf.bflangs[b];
				var mPopup = document.getElementById("bf-statusbarcontextmenu"); 

				if (mPopup.hasChildNodes())
				{
					var elements = mPopup.childNodes;
				  	for (var i=0;i<elements.length; i++) {
						if(elements[i].label == lbl){
							return;
						}
					}
				}
				var mi = mPopup.appendChild(document.createElement("menuitem")); 
				//var cmd = String("bf.switchLang('" + sel + "');"); 
				var cmd = String("bf.switchLang('" + sel + "', 0);"); 
				mi.setAttribute("oncommand", cmd);
				mi.setAttribute("label", lbl);
				var items = navigator.preference("extensions.babelmousish.usermenue").split(",");
				items.push(a + b); 
				navigator.preference("extensions.babelmousish.usermenue", items.join(","));
		},


		addInitialLangs: function()
		{
			//selected languages according web usage statistics (Note: Those statistics differ widely - choose the best one!)
			//do not initially add auto, as it has some known drawbacks
			var initialLangs = "ar|ca|cs|da|de|el|en|es|fi|fr|hu|it|iw|ja|ko|nl|no|pl|pt|ro|ru|sv|th|tr|vi|zh|id";
			var guessed = bf.guessInitLang();
			if(initialLangs.indexOf(guessed) == -1)
				initialLangs = initialLangs + "|" + guessed;
			navigator.preference("extensions.babelmousish.availlangs", initialLangs);
		},


		initOverlay: function()
		{
    			//try{window.removeEventListener("load", bfOverlay.initOverlay, false);}catch(e){;}

				if(gBrowser && gBrowser.tabContainer)
					gBrowser.tabContainer.addEventListener("TabSelect", bf.TabSelectedEvent, false); //detect tab selection -> to hide box and panel
				if(!String(navigator.preference("extensions.babelmousish.availlangs")).length)
				{ //Babelfish first run
					bfOverlay.addInitialLangs();
				}else //check for invalid languages and remove them
				{
					var currentLangs = navigator.preference("extensions.babelmousish.availlangs").split("|");
					for (var i = 0; i < currentLangs.length; i++){
						if(!bf.bflangs[currentLangs[i]]){
							var exp = new RegExp(String(currentLangs[i]) + '[\|]?', 'g');
							navigator.preference("extensions.babelmousish.availlangs", String(navigator.preference("extensions.babelmousish.availlangs")).replace(exp, ""));
						}

					}
					currentLangs = null;
				}

				if(navigator.preference("extensions.babelmousish.usermenue").length == 0 && !navigator.preference("extensions.babelmousish.guessedmenu")){
					//Most likely first run
					navigator.preference("extensions.babelmousish.guessedmenu", 1);
					bfOverlay.initializeLanguageMenu();
				}
				var from = undefined;
				var to = undefined;
				try{
					from = navigator.preference("extensions.babelmousish.translation.from");
					to = navigator.preference("extensions.babelmousish.translation.to");
				}catch(e){}//if not exist result is undefined
				if(from == undefined || to == undefined || from == "" || to == "")
				{
					//Most likely first run
					from = "es"; 
					to = "en";
					var guessed = bf.guessInitLang();
					if(guessed != "en"){
						from = "en"; 
						to = guessed;
					}
			    	navigator.preference("extensions.babelmousish.translation.from", from);
			    	navigator.preference("extensions.babelmousish.translation.to", to);
				}


				var showmenue = document.getElementById("BabelFishPreferencesID");//hide Tools Menu entry?
				if(showmenue != null){
					if(navigator.preference("extensions.babelmousish.prefsinmenue"))
		  				showmenue.hidden = false;
					else
		  				showmenue.hidden = true;
				}
		
				var showpanel = document.getElementById("bfstatusbarID");//hide status-bar icon?
				if(showpanel != null){
					if(navigator.preference("extensions.babelmousish.statusbaricon"))
		  				showpanel.hidden = false;
					else{
		  				showpanel.hidden = true;
						return;
					}
				}

				//document.getElementById("bfdetBtn").addEventListener("mouseup", function() { bf.detectButton_clickEvent() }, true);
				//Update addon version
				var version = String(bf_fileio.GetAddonVersion());
				version = version.replace(/\./g, "");
				navigator.preference("extensions.babelmousish.version", version);
				if(navigator.preference("extensions.babelmousish.disable_xul_cache_default") == 0)
					Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch).clearUserPref("nglayout.debug.disable_xul_cache");
				//navigator.preference("nglayout.debug.disable_xul_cache", false);
				navigator.preference("extensions.babelmousish.disable_xul_cache_default", 2);

				//welcome user
				if(!navigator.preference("extensions.babelmousish.welcome"))
				{
					navigator.preference("extensions.babelmousish.welcome", 2);
					bfOverlay.HelpPageDisplay("chrome://babelmousish/skin/BabelFish.html");
				}

		},


		populateContext: function(id)
		{
        return;
				document.getElementById("DetectContextID").setAttribute("class", "menuitem-iconic");
				document.getElementById("DetectContextID").setAttribute("image", "chrome://babelmousish/skin/babelfish.png");
				document.getElementById("TranslateContextPageID").setAttribute("class", "menuitem-iconic");
				document.getElementById("TranslateContextPageID").setAttribute("image", "chrome://babelmousish/skin/babelfish.png");
				document.getElementById("TranslateContextID").setAttribute("class", "menuitem-iconic");
				document.getElementById("TranslateContextID").setAttribute("image", "chrome://babelmousish/skin/babelfish.png");
        //document.getElementById("TranslateContextID").setAttribute("label", "Translate...");
		},



		populateSBContext: function()
		{

				var mPopup = document.getElementById("bf-statusbarcontextmenu"); 
				if(!mPopup) 
					return;
				while (mPopup.hasChildNodes()) {
				  mPopup.removeChild(mPopup.firstChild);
				}
				//add help, prefs,...
				var mi = null;
				mi = mPopup.appendChild(document.createElement("menuitem")); 
				mi.setAttribute("oncommand", "bfOverlay.HelpPageDisplay('chrome://babelmousish/skin/BabelFish.html')");
				mi.setAttribute("label", "Help");
				mi = mPopup.appendChild(document.createElement("menuitem")); 
				mi.setAttribute("oncommand", "bf.openConfigWindow(0)");
				mi.setAttribute("label", "Preferences");
				mi = mPopup.appendChild(document.createElement("menuseparator"));

				//load custom languages
				var items = navigator.preference("extensions.babelmousish.usermenue").split(",");
				var isinmenu = false;
				for (var i=0;i<items.length; i++) //check if current translation is in custom language menu
				{
					if(items[i].length >= 4) //additional check is necessary
					{ 
						var a = items[i].slice(0, 2);
						var b = items[i].slice(2, 4);
						if(!bf.bflangs[a] || !bf.bflangs[b])
							continue;
						if(a == navigator.preference('extensions.babelmousish.translation.from') && b == navigator.preference('extensions.babelmousish.translation.to')){
							isinmenu = true;
							break;
						}
					}
				}

				//create remove+add custom items
				if(bf.bflangs[navigator.preference('extensions.babelmousish.translation.from')] != undefined && bf.bflangs[navigator.preference('extensions.babelmousish.translation.to')] != undefined){
						//add custom translations
						mi = mPopup.appendChild(document.createElement("menuitem")); 
						mi.setAttribute("oncommand", "bfOverlay.addCustomLang(navigator.preference('extensions.babelmousish.translation.from') + navigator.preference('extensions.babelmousish.translation.to'))");
						mi.setAttribute("label", "Add '" + bf.bflangs[navigator.preference('extensions.babelmousish.translation.from')] + " to " + bf.bflangs[navigator.preference('extensions.babelmousish.translation.to')] + "' to menu...");
						mi.setAttribute("disabled", isinmenu);
						mi = mPopup.appendChild(document.createElement("menuitem")); 
						mi.setAttribute("oncommand", "bfOverlay.removeFromMenu(navigator.preference('extensions.babelmousish.translation.from') + navigator.preference('extensions.babelmousish.translation.to'))");
						mi.setAttribute("label", "Remove '" + bf.bflangs[navigator.preference('extensions.babelmousish.translation.from')] + " to " + bf.bflangs[navigator.preference('extensions.babelmousish.translation.to')] + "' from menu...");
						mi.setAttribute("disabled", !isinmenu);
						mi = mPopup.appendChild(document.createElement("menuseparator"));
				}

				//create custom languages to menu
				var itemsnew = [];
				for (var i=0;i<items.length; i++)
				{
					if(items[i].length >= 4) //additional check is necessary
					{ 
						var a = items[i].slice(0, 2);
						var b = items[i].slice(2, 4);
						if(!bf.bflangs[a] || !bf.bflangs[b])
							continue;
						itemsnew.push(a + b); //rebuild index to prevent corruption
						mi = mPopup.appendChild(document.createElement("menuitem")); 
						//var cmd = String("bf.switchLang('" + items[i] + "');"); 
						var cmd = String("bf.switchLang('" + items[i] + "', 0);"); 
						mi.setAttribute("oncommand", cmd);
						mi.setAttribute("label", "From " + bf.bflangs[a] + " To " + bf.bflangs[b]);
					}
				}
				navigator.preference("extensions.babelmousish.usermenue", itemsnew.join(",")); //rebuild index to prevent corruption
		},


		refreshTooltip: function()
		{
				var sbIcon = document.getElementById("bf-statusbarimg"); 
				if(!sbIcon)
					return;
				document.getElementById("bf-statusbar-tooltip-leftclick").setAttribute("value", "Leftclick: Set languages");
				document.getElementById("bf-statusbar-tooltip-rightclick").setAttribute("value", "Rightclick: Custom translations, preferences, help");
				document.getElementById("bf-statusbar-tooltip-doubleclick").setAttribute("value", "Doubleclick: Disable / enable");
		        if (!navigator.preference("extensions.babelmousish.enabled")) {
		            sbIcon.src = 'chrome://babelmousish/skin/nobabelfish.png';
								document.getElementById("bf-statusbar-tooltip-languages").setAttribute("value", "BabelFish is disabled");
		        } else {
		            sbIcon.src = 'chrome://babelmousish/skin/babelfish.png';
								document.getElementById("bf-statusbar-tooltip-languages").setAttribute("value", "Translation: " + bf.bflangs[navigator.preference("extensions.babelmousish.translation.from")] + " -> " + bf.bflangs[navigator.preference("extensions.babelmousish.translation.to")]);
		        }
				return true;
		},



			


		populateSourcePopup: function(id, nr)//nr=0 for single menue, nr=1 or 2 for double menu (first source, than target)
		{
				var mPopup = document.getElementById(id); 

				while (mPopup.hasChildNodes()) {
				  mPopup.removeChild(mPopup.firstChild);
				}

				//add source headline
				var mi = mPopup.appendChild(document.createElement("menuitem")); 
				mi.setAttribute("label", "Source: " + bf.bflangs[navigator.preference("extensions.babelmousish.translation.from")] + " (to " +  bf.bflangs[navigator.preference("extensions.babelmousish.translation.to")] + ")");
				mi.setAttribute('style','color: red; font-weight:bold');
				mi.setAttribute("tooltiptext", "Click here to SKIP changing the source language (advance to next dialog)");
				mi.setAttribute("class", "menuitem-iconic");
				mi.setAttribute("image", "chrome://babelmousish/skin/babelfish.png");

				//add language configuration
        		if (navigator.preference("extensions.babelmousish.langscfginlangs") != 0){ //value can be 0, 1 or 2!
					mi = mPopup.appendChild(document.createElement("menuitem")); 
					mi.setAttribute("label", "Show more/less languages...");
					mi.setAttribute("oncommand", "bf.openConfigWindow(1)");
					mi.setAttribute("tooltiptext", "Available languages configuration...");
					mi.setAttribute("class", "menuitem-iconic");
					mi.setAttribute("image", "chrome://babelmousish/skin/tools.png");
				}

				//add flags
				var currentLangs = navigator.preference("extensions.babelmousish.availlangs").split("|");
				currentLangs.sort();
				for (var i = 0; i < currentLangs.length; i++){
					mi = mPopup.appendChild(document.createElement("menuitem")); 
					mi.setAttribute("label", bf.bflangs[currentLangs[i]] + " - " + currentLangs[i]);
					//mi.setAttribute("oncommand", "bf.switchLang('" + currentLangs[i] + navigator.preference("extensions.babelmousish.translation.to") + "'); bfOverlay.refreshTooltip()");
					mi.setAttribute("oncommand", "bf.switchLang('" + currentLangs[i] + navigator.preference("extensions.babelmousish.translation.to") + "', " + nr + "); bfOverlay.refreshTooltip()");
					mi.setAttribute("class", "menuitem-iconic");
					mi.setAttribute("image", "chrome://babelmousish/skin/" + currentLangs[i] + ".gif");
				}
				currentLangs = null;
		},




		populateTargetPopup: function(id, nr)
		{

				var mPopup = document.getElementById(id); 

				while (mPopup.hasChildNodes()) {
				  mPopup.removeChild(mPopup.firstChild);
				}

				//add target headline
				var mi = mPopup.appendChild(document.createElement("menuseparator"));
				mi = mPopup.appendChild(document.createElement("menuitem")); 
				mi.setAttribute("label", "Target: " + bf.bflangs[navigator.preference("extensions.babelmousish.translation.to")] + " (from " +  bf.bflangs[navigator.preference("extensions.babelmousish.translation.from")] + ")");
				mi.setAttribute('style','color: blue; font-weight:bold');
				mi.setAttribute("tooltiptext", "Click here to SKIP changing the target language");
				mi.setAttribute("class", "menuitem-iconic");
				mi.setAttribute("image", "chrome://babelmousish/skin/babelfish.png");

				//add language configuration
        		if (navigator.preference("extensions.babelmousish.langscfginlangs") != 0){ //value can be 0, 1 or 2!
					mi = mPopup.appendChild(document.createElement("menuitem")); 
					mi.setAttribute("label", "Show more/less languages...");
					mi.setAttribute("oncommand", "bf.openConfigWindow(1)");
					mi.setAttribute("tooltiptext", "Available languages configuration...");
					mi.setAttribute("class", "menuitem-iconic");
					mi.setAttribute("image", "chrome://babelmousish/skin/tools.png");
				}

				//add flags
				var currentLangs = navigator.preference("extensions.babelmousish.availlangs").split("|");
				currentLangs.sort();
				for (var i = 0; i < currentLangs.length; i++){
					if(currentLangs[i] == "xx") 
						continue; //auto-language
					mi = mPopup.appendChild(document.createElement("menuitem")); 
					//mi.setAttribute("oncommand", "bf.switchLang('" + navigator.preference("extensions.babelmousish.translation.from") + currentLangs[i] + "'); bf.popup = false; bfOverlay.refreshTooltip()");
					mi.setAttribute("oncommand", "bf.switchLang('" + navigator.preference("extensions.babelmousish.translation.from") + currentLangs[i] + "', " + nr + "); bf.popup = false; bfOverlay.refreshTooltip()");
					mi.setAttribute("label", bf.bflangs[currentLangs[i]] + " - " + currentLangs[i]);
					mi.setAttribute("class", "menuitem-iconic");
					mi.setAttribute("image", "chrome://babelmousish/skin/" + currentLangs[i] + ".gif");
				}
		},




		removeFromMenu: function(sel)
		{

				//sel = bf.openLangConfig(2);
				if (sel == null)
					return;
				var mPopup = document.getElementById("bf-statusbarcontextmenu"); 

				if (!mPopup.hasChildNodes()){
					alert("Nothing to remove!");
					return;
				}

				var a = sel.slice(0, 2);
				var b = sel.slice(2, 4);
				if(sel.length == 6){
					a = sel.slice(0, 4);
					b = sel.slice(4, 6);
				}
				var lbl = "From " + bf.bflangs[a] + " To " + bf.bflangs[b];
				var elements = mPopup.childNodes;
			  for (var i=0;i<elements.length; i++) {
					if(elements[i].label == lbl)
						mPopup.removeChild(mPopup.childNodes[i]);
				}
				//remove from prefs too
			  var items = navigator.preference("extensions.babelmousish.usermenue").split(",");
			  for (var i=0;i<items.length; i++) {
					if(items[i] == a + b)
						items.splice(i, 1);
				}
				navigator.preference("extensions.babelmousish.usermenue", items.join(","));
		},




		toggleActive: function()
		{
			var sbIcon = document.getElementById("bf-statusbarimg"); 
            if (navigator.preference("extensions.babelmousish.enabled")){ 
                bf.killToolTip();
				bf.killPanel();
				navigator.preference("extensions.babelmousish.enabled", false);
            }else 
				navigator.preference("extensions.babelmousish.enabled", true);
			bfOverlay.refreshTooltip();
		},




		captureClick: function(e){
			var rightclick = 0;
			if( typeof( e.which ) == 'number' ) 
					rightclick = (e.which == navigator.preference("extensions.babelmousish.rightclick.codeW"));
			else if( typeof( e.button ) == 'number' ) 
					rightclick = (e.button == navigator.preference("extensions.babelmousish.rightclick.codeB"));
			if(rightclick)
			{
				var bfsourcemenu = document.getElementById("bf-sourcemenu");
				var bftargetmenu = document.getElementById("bf-targetmenu");
				bfsourcemenu.onpopuphidden = null;
				bfsourcemenu.hidePopup();
				bftargetmenu.hidePopup();
				return;
			}
			if( e.detail == 1 && bfOverlay.clickTimer == undefined )
			{//single click
		    	bfOverlay.clickTimer = setTimeout(function(){
		    			bfOverlay.clickTimer = undefined;
							var bfsourcemenu = document.getElementById("bf-sourcemenu");
							var bftargetmenu = document.getElementById("bf-targetmenu");

							if(bfsourcemenu.state != "closed" || bftargetmenu.state != "closed")
								return;
							bfsourcemenu.setAttribute("onpopuphidden", "var bftargetmenu = document.getElementById('bf-targetmenu'); bftargetmenu.setAttribute('onpopuphidden', 'if(bf.getbabelFish() || bf.isPanelshown()) bf.prepareRequest(bf.service, true, null);'); bf.popup = true; bftargetmenu.openPopupAtScreen(" + e.screenX + ", " + e.screenY + ", false);");
							bf.popup = true;
							bfsourcemenu.openPopupAtScreen(e.screenX, e.screenY, false);
							
						}, 400, e);//ClickSpeed
		  }
		  else if( e.detail == 2 && bfOverlay.clickTimer != undefined){//doubleclick
		    clearTimeout(bfOverlay.clickTimer);
		    bfOverlay.clickTimer = undefined;
		    bfOverlay.toggleActive();
		  }
		},





};