


var bf_fileio = {    
   digitArray: new Array('0','1','2','3','4','5','6','7','8','9','a','b','c','d','e','f'),


   LOG: function(text,debug)
   {
       var consoleService = Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService);
       if(consoleService && ((navigator.preference("extensions.babelmousish.debug") && debug) || !debug)) 
          consoleService.logStringMessage(text);
   },



   GetAddonVersion: function (){
		var em = Components.classes["@mozilla.org/extensions/manager;1"].getService(Components.interfaces.nsIExtensionManager);
		if(!em)
			return 0;  
		var addon = em.getItemForID("{ca0849e8-2c76-42ae-9abe-34e14d337acf}");  
		if(addon)
			return addon.version;  
		return 0;
   },




   PluginFileExisting: function (){
		var srcfile = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
		var srcfilepath = bf_fileio.chromeToPath("chrome://babelmousish/content/bfplugin.js");
		srcfile.initWithPath(srcfilepath);
		return srcfile.exists();
   },


     
     
     
   incomatibleAlert: function (id){
      var em = Components.classes["@mozilla.org/extensions/manager;1"].getService(Components.interfaces.nsIExtensionManager); 
      var item = em.getItemForID(id);
      if(item) 
      {
			if(confirm("WARNING: BabelFish is NOT compatible with the '" + item.name + "' addon!\r\nBabelFish will not work correctly.\r\nWould you like to uninstall the incompatible addon?"))
			{
				em.uninstallItem(id);
				alert("Scheduled uninstall for the incompatible addon.\r\nONE MORE RESTART IS NECESSARY!");
			}
	  }
   },     
     
     
   

   CheckPluginLoadOverlay: function (){
      //check for incompatible addons

      //bf_fileio.incomatibleAlert("{63df8e21-711c-4074-a257-b065cadc28d8}");  //CuteMenus

      //check for valid definition files
      if(
         typeof bfplugin == "undefined" || /*typeof bfplugin.pluginName == "undefined" ||*/
         typeof bfplugin.service1Name == "undefined" || typeof bfplugin.service2Name == "undefined" || typeof bfplugin.service3Name == "undefined" ||
         typeof bfplugin.service1URL == "undefined" || typeof bfplugin.service2URL == "undefined" || typeof bfplugin.service3URL == "undefined" ||
         typeof bfplugin.service1LanguageCodes == "undefined" || typeof bfplugin.service2LanguageCodes == "undefined" || typeof bfplugin.service3LanguageCodes == "undefined" ||
         typeof bfplugin.service1ProcessResponse == "undefined" || typeof bfplugin.service2ProcessResponse == "undefined" || typeof bfplugin.service3ProcessResponse == "undefined" /*||
		 typeof bfplugin.detectionURL == "undefined" */
      )
      {
         try{
		 	navigator.preference("extensions.babelmousish.plugin", "");
            //navigator.preference("extensions.babelmousish.plugin", navigator.preference("extensions.babelmousish.pluginDefault"));
            bf_fileio.createPluginFile(true);
            navigator.preference("extensions.babelmousish.pluginRestartNeeded", 0);
            alert("BabelFish found missing or invalid service definition data and tried to fix the problem by installing default definitions.");
         }catch(e){
            navigator.preference("extensions.babelmousish.pluginRestartNeeded", 3);
            alert("BabelFish found invalid service definition data.\r\nThe problem could not be fixed.\r\nBabelFish will not work. Error: " + e);
         }
      }

      //dynamically load overlay
      //document.loadOverlay("chrome://babelmousish/content/bfoverlay.xul", null); //fixes incompatibility with CuteMenus
   },



   createPluginFile: function (createdefault){
		//try-catch handler located in calling routines
		var plugin;
		var srcfile = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
		var srcfilepath = bf_fileio.chromeToPath("chrome://babelmousish/content/bfplugin.js");
		srcfile.initWithPath(srcfilepath);
		if(srcfile.exists())
			srcfile.remove(false);
		if(!srcfile.exists())
		  srcfile.create(Components.interfaces.nsIFile.NORMAL_FILE_TYPE, 420);
		var filestream = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance(Components.interfaces.nsIFileOutputStream);
		filestream.init(srcfile, 0x04|0x08|0x20, 420, 0);
		if(!(navigator.preference("extensions.babelmousish.plugin") && String(navigator.preference("extensions.babelmousish.plugin")).length)){
			createdefault = true;
		}
		if(createdefault){
			navigator.preference("extensions.babelmousish.plugin", "");
			plugin = bf_fileio.decodeHex(String(navigator.preference("extensions.babelmousish.pluginDefault")));
		}else
			plugin = bf_fileio.decodeHex(String(navigator.preference("extensions.babelmousish.plugin")));
		filestream.write(plugin, plugin.length);
		filestream.close();
		if(!srcfile.exists())
			throw "Could not write data to Firefox profile";
		if(typeof bfplugin == "undefined"){
			navigator.preference("extensions.babelmousish.pluginRestartNeeded", 0);
		}else
			throw "Old definitions were not unloaded";
		bf_fileio.LOG("BabelFish: Installed service definitions!");
   },


   
   getProfilePath : function()
   // get the path to the user's home (profile) directory
   {
       var path = Components.classes["@mozilla.org/file/directory_service;1"]
                               .getService(Components.interfaces.nsIProperties)
                               .get("ProfD", Components.interfaces.nsIFile);
       return path;
   },
   
   
   
   
   chromeToPath : function (aPath) {
		if (!aPath || !(/^chrome:/.test(aPath)))
			return null; //not a chrome url
		var rv;
		var ios = Components.classes['@mozilla.org/network/io-service;1'].getService(Components.interfaces["nsIIOService"]);
		var uri = ios.newURI(aPath, "UTF-8", null);
		var cr = Components.classes['@mozilla.org/chrome/chrome-registry;1'].getService(Components.interfaces["nsIChromeRegistry"]);
		rv = cr.convertChromeURL(uri).spec;
		if (/^file:/.test(rv))
			rv = bf_fileio.urlToPath(rv);
		else
			rv = bf_fileio.urlToPath("file://"+rv);
		return rv;
   },
   
   
   urlToPath : function (aPath) {
		if (!aPath || !/^file:/.test(aPath))
			return null;
		var rv;
		var ph = Components.classes["@mozilla.org/network/protocol;1?name=file"].createInstance(Components.interfaces.nsIFileProtocolHandler);
		rv = ph.getFileFromURLSpec(aPath).path;
		return rv;
   },
   


   //Hex encode/decode from http://ostermiller.org
   ntos: function (n){
      n=n.toString(16);
      if (n.length == 1) n="0"+n;
         n="%"+n;
      return unescape(n);
   },




   toHex: function (n){
      var result = ''
      var start = true;
      for (var i=32; i>0;){
         i-=4;
         var digit = (n>>i) & 0xf;
         if (!start || digit != 0){
            start = false;
            result += bf_fileio.digitArray[digit];
         }
      }
      return (result==''?'0':result);
   },


   pad: function (str, len, pad){
      var result = str;
      for (var i=str.length; i<len; i++){
         result = pad + result;
      }
      return result;
   },


   encodeHex: function (str){
      var result = "";
      for (var i=0; i<str.length; i++){
         var chrcode = str.charCodeAt(i);
         if((chrcode < 32 && chrcode != 10 && chrcode != 13) || chrcode > 128)
            chrcode = 32;
         result += bf_fileio.pad(bf_fileio.toHex(chrcode&0xff),2,'0');
      }
      return result;
   },


   decodeHex: function (str){
      //str = str.replace(new RegExp("s/[^0-9a-zA-Z]//g"));
      str = str.replace(/[^0-9a-zA-Z]/g);
      var result = "";
      var nextchar = "";
      for (var i=0; i<str.length; i++){
         nextchar += str.charAt(i);
         if (nextchar.length == 2)
		{
            result += bf_fileio.ntos(parseInt('0x'+nextchar));
            nextchar = "";
         }
      }
      return result;
   },

}